#include<iostream>
#include<cstdlib>
#include<ctime>
#include<omp.h>
using namespace std;
int w=24;
const int M=1<<w;
int main(){
 double * a;
 double * tmp;
 int nproc=2;
 cout.precision(4);
 srand((unsigned) time(0));
 a=new double[M];
 for(int i=0;i<M;i++) a[i]=(double)rand()/rand();

 //for(int i=0;i<M;i++) cout<<a[i]<<", ";
 //cout<<endl;
      int n,m;
      n=2;
      m=1;
      tmp=new double[M];
      cout<<"Kezdi a rendezest: "<<endl;
      while(n<=M){
        int q=0;
        int w=0;
        int z=0;
        while (q<=(M/n)){
         int low,mid,up,i,j;
         #pragma omp parallel num_threads(nproc) shared(a,tmp,n) private(low,up,mid,i,j)
         {	
           int id=omp_get_thread_num();
           if(id==0){low=id+w*nproc; mid=low+m-1; up=low+(2*m)-1;}
           else{low=w*nproc+id*2*m; mid=low+m-1; up=low+(2*m)-1;}
           int lepes=up-low+1;
           i=j=0;
           while((i+j)<lepes)
            {
            	if((low+i)>(mid))
            	{
            		tmp[low+i+j]=a[mid+1+j];
            		j++;
				}
				else if((mid+1+j)>up)
				{
					tmp[low+i+j]=a[low+i];
					i++;
				}
				else if(a[low+i]<a[mid+1+j])
				{
					tmp[low+i+j]=a[low+i];
					i++;
				}
				else 
				{
					tmp[low+i+j]=a[mid+1+j];
					j++;
				}
				
			}
			for(int x=0;x<lepes;x++) a[low+x]=tmp[low+x];
		}
		w=z*n;
		z++;
		if(nproc==1) break;
		if((n*nproc)==M) nproc/=2;
		q+=nproc;
	 }
	 q=0;
	 m+=m;
	 n*=2;
  }
  cout<<"vege a rendezesnek!";
  delete [] tmp;
  //for(int l=0;l<M;l++) cout<<a[l]<<", ";
  cout<<endl;
 /*cout<<"First 10: ";
 for(int i=0;i<10;i++) cout<<a[i]<<", ";
 cout<<endl<<"Middle 10: ";
 for(int i=(M/2);i<(M/2)+10;i++) cout<<a[i]<<", ";
 cout<<endl<<"Last 10: ";
 for(int i=(M-10);i<M;i++) cout<<a[i]<<", ";
 cout<<endl;*/
 delete [] a;
}
